#include <stdio.h>
#include <unistd.h>
#include <sys/io.h>

main(int argc, char *argv[])
{
  int i, port, len;
  unsigned char last[512];
  
  if (argc == 3) {
  port = atoi(argv[1]);
  len = atoi(argv[2]);
  } else {
  port = 0x208;
  len = 8;
  }
  iopl(2);
  ioperm(0, 0x3ff, 1);

  outb(0x87, 0x2e);
  outb(0x87, 0x2e);
  outb(0x07, 0x2e);
  outb(0x07, 0x2f);
  outb(0x30, 0x2e);
  outb(0x01, 0x2f);
  // set all pins to output
  outb(0xf0, 0x2e);
  outb(0x0, 0x2f);  // 0xf8 for 3 bit
  // CR29 change Game to GPIO
  outb(0x29, 0x2e);
  outb(0x80, 0x2f);
  // set base address to 0x208
  outb(0x62, 0x2e);
  outb(0x02, 0x2f);
  outb(0x63, 0x2e);
  outb(0x08, 0x2f);

  outb(0x60, 0x2e);
  fprintf(stderr, "%02x\n", inb(0x2f));
  outb(0x61, 0x2e);
  fprintf(stderr, "%02x\n", inb(0x2f));
  outb(0x62, 0x2e);
  fprintf(stderr, "%02x\n", inb(0x2f));
  outb(0x63, 0x2e);
  fprintf(stderr, "%02x\n", inb(0x2f));

  outb(0xaa, 0x2e);

  while (1) {
    fprintf(stderr, "1) %02x\n", inb(0x208));
    outb(0x07, 0x208);
    fprintf(stderr, "2) %02x\n", inb(0x208));
    sleep(2);
    outb(0, 0x208);
    fprintf(stderr, "3) %02x\n", inb(0x208));
    sleep(2);
  }
}
